import json

from .scene import Scene
from .action import Publish, TasmotaShutter
from .watch import Watch

class Sleep(Scene):

    ON = [
        Publish('cmnd/tasmota/screen/Screen/POWER').Payload('OFF').Qos(1)\
                .CheckResponse('stat/tasmota/screen/Screen/POWER', 'OFF', 3),
        Publish('cmnd/tasmota/light/LivingroomFireplace/POWER').Payload('OFF').Qos(1),

        #Shutter
        TasmotaShutter('Bedroom1x1').Close(),
        TasmotaShutter('Bedroom1x2').Close(),
        TasmotaShutter('Staircase1').Close(),
        TasmotaShutter('Bathroom').Close(),

        #Chambre
        Publish('zwave2mqtt/7/67/1/1/set').Payload('17').Qos(1)\
                .CheckResponse('zwave2mqtt/7/67/1/1', lambda p: json.loads(p)['value'] == 17, 3),
        #RdC
        Publish('zwave2mqtt/6/67/1/1/set').Payload('19').Qos(1)\
                .CheckResponse('zwave2mqtt/6/67/1/1', lambda p: json.loads(p)['value'] == 19, 3),
        Publish('zwave2mqtt/5/67/1/1/set').Payload('19').Qos(1)\
                .CheckResponse('zwave2mqtt/5/67/1/1', lambda p: json.loads(p)['value'] == 19, 3),
    ]

    WATCH = [
            #HomeCinema
            Watch('stat/tasmota/screen/Screen/POWER', 'OFF'),
            #Lights
            Watch('stat/tasmota/light/LivingroomFireplace/POWER', 'OFF'),
            #Shutter
            Watch('cmnd/tasmota/shutter/Bedroom1x1/ShutterOpen'),
            Watch('cmnd/tasmota/shutter/Bedroom1x2/ShutterOpen'),
            Watch('cmnd/tasmota/shutter/Staircase1/ShutterOpen'),
            Watch('cmnd/tasmota/shutter/Bathroom/ShutterOpen'),
            #Thermostat
            Watch('zwave2mqtt/7/67/1/1', lambda p: json.loads(p)['value'] == 17),
            Watch('zwave2mqtt/6/67/1/1', lambda p: json.loads(p)['value'] == 19),
            Watch('zwave2mqtt/5/67/1/1', lambda p: json.loads(p)['value'] == 19),
    ]
