from typing import Union, Callable

class Watch(object):

    def __init__(self, topic: str, payload: Union[str, Callable[[str],bool]] = None):
        self.__topic = topic

        if callable(payload):
            self.__check_payload = payload
        elif payload == None:
            self.__check_payload = lambda _: False
        else:
            self.__check_payload = lambda x: x == payload

    @property
    def topic(self) -> str:
        return self.__topic

    def check(self, topic: str, payload: str) -> bool:
        if topic == self.topic and self.__check_payload(payload):
            return True
        else:
            return False
